package com.kfi.dm.gui.core.event.test;

import com.kfi.dm.gui.core.event.Event;
import com.kfi.dm.gui.core.event.EventBus;
import com.kfi.dm.gui.core.event.EventSubscriber;

public class TestEventBus {

	public static void main(String[] args) {
		EventBus eventBus = new EventBus();
		eventBus.enableLogging();
		
		Foo foo = new Foo();
		eventBus.addSubscriber(foo);
		
		EventA eventA = new EventA("First event");
		eventBus.fire(eventA);
		
		EventB eventB = new EventB("Second event");
		eventBus.fire(eventB);
	}

	@Event
	private static class EventA {
		private String message;
		
		public EventA(String message) {
			this.message = message;
		}
		
		public String getMessage() {
			return message;
		}
	}
	
	@Event
	private static class EventB {
		private String message;
		
		public EventB(String message) {
			this.message = message;
		}
		
		public String getMessage() {
			return message;
		}
	}

	public static class Foo {
		@EventSubscriber(EventA.class)
		public void onEventA(EventA event) {
			System.out.println("Foo.onEventA() - " + event.message);
		}
		
		@EventSubscriber(EventB.class)
		public void onEventB(EventB event) {
			System.out.println("Foo.onEventB() - " + event.message);
		}
	}
}
